; ADCDACINT_Rn_504.a51	XFER from ADC to DAC on interrupt, using P2 and R_n
;   	5/04
; read ADC, write to DAC, start ADC each time interrupted

	$NOSYMBOLS

; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC)

	 STACKBOT EQU 80h	; Not necessary, but a good place for it

	ORG 0H
	AJMP STARTUP

	ORG 0E0h
				
STARTUP: ACALL    INITDACPTRS         ;GO INITIALIZE ptrs for ADC & DAC

; ----NOW ENABLE INTERRUPTS----
	SETB TCON.0		; make INT0 Edge-sensitive	
	SETB IE.0		; enable INT0	
	SETB IE.7		; Global int enable

STUCK:	SJMP STUCK		; AWAIT INTERRUPTS 


;** INITS ***************

INITDACPTRS:	MOV P2,#80h	; set up top half of address as I/O base
	MOV R0, #3h		; set up 8-bit index register to ADC
	MOV R1,#2h		; set up another register to point to DAC
	MOV @R0,A		; For first pass: send anything--just a pulse to START ADC
	RET	
	
;------------------------------
; ISR: ADC-->DAC

ISR:		MOVX A, @R0		; read ADC (bad, first pass, OK ever after)
	MOVX @R0,A			; start ADC for next pass
	MOVX @R1, A			; ...and send sample to DAC	
	RETI	
	
;----------VECTOR, FROM INTERRUPT:	
	ORG INT0VECTOR
	
	LJMP ISR			; hop out to the wide open spaces

END
	

